      implicit real*8 (a-h,o-z)

      include 'CONSTCOM.'
      INCLUDE 'PDFCOM.'

      real*8 q2hera(11),xmin(11),xmax(11)
      data q2hera/ 2d0, 4d0, 6.5d0, 12d0, 20d0, 35d0, 60d0
     ,          , 120d0, 200d0, 400d0, 1000d0/

      data xmin/ 2d-5, 6d-5, 1d-4, 1.2d-4, 2d-4, 5d-4, 7d-4
     ,  ,1d-3, 3d-3, 5d-3, 0.01d0/

      data xmax/ 2d-3, 4d-3, 6d-3, 0.01d0, 0.02d0, 0.03d0, 0.05d0
     ,  ,0.05d0, 0.05d0, 0.05d0, 0.05d0/  

#ifdef TOYLH
      print *,'******THIS BENCH IS INAPPLICABLE FOR THE TOYLH PDFS'
      STOP
#endif

!  Set up constants, grid spacing, etc.
      call initgridconst

!  Set up the 3-flavour NNLO PDFs and fill the 3-flavour PDF grid
!  including the strong coupling values
      kschemepdf=0
      kordpdf=2
      call pdffillgrid

!  Set the factorization scale as sqrt(Q2*hqscale1 + 4m^2*hqscale2) for the 
!  pair heavy-quark production and as sqrt(Q2*hqscale1 + m^2*hqscale2) for the 
!  single heavy-quark production
      hqscale1=1d0
      hqscale2=1d0

      print *,'The electron-proton DIS c-quark NC semi-inclusive', 
     -' structure function F_2', 
     -' the NNLO QCD approximation and the running-mass definition',
     -' (first column: the momentum transferred squared, the second',
     -' column: the value of Bjorken,',
     -' variable x, the third column: the value of F_2' 

      kordhq=2
      msbarm=.true.
! Set the c-quark mass at the value obtained in [arXiv:1011.5790]
      rmass(8)=1.175
! The non-singlet contribution is included 
      hqnons=.true.

      do kk=1,11
        q2=q2hera(kk)
        bmin=xmin(kk)
        bmax=xmax(kk)
        nbin=30
        bin=(log(bmax)-log(bmin))/(nbin-1)

        do nn=1,nbin
          xb=bmin*exp(bin*(nn-1))
          a1=f2charm_ffn(xb,q2,8)
          write (*,fmt='(6e13.4)') q2,xb,a1
        end do
      end do 

      stop
      end
