      implicit real*8 (a-h,o-z)

      include 'CONSTCOM.'
      INCLUDE 'PDFCOM.'

#ifdef TOYLH
      print *,'******THIS BENCH IS INAPPLICABLE FOR THE TOYLH PDFS'
      STOP
#endif

!  Set up constants, grid spacing, etc.
      call initgridconst

!  Set up the 3-flavour NNLO PDFs and fill the 3-flavour PDF grid
!  including the strong coupling values
      kschemepdf=0
      kordpdf=2
      call pdffillgrid

!  Set the factorization scale as sqrt(Q2*hqscale1 + 4m^2*hqscale2) for the 
!  pair heavy-quark production and as sqrt(Q2*hqscale1 + m^2*hqscale2) for the 
!  single heavy-quark production
      hqscale1=1d0
      hqscale2=1d0
! The non-singlet contribution is excluded 
      hqnons=.false.

! benchmark output of the CC structure functions at different c-quark mass 

      print *,'The neutrino-proton DIS c-quark CC semi-inclusive', 
     -' structure functions in', 
     -' the NLO QCD approximation and the pole mass definition at the',
     -' value of Bjorken variable x=0.001 and the transferred momentum', 
     -' squared Q2=10 GeV**2 (first column: the c-quark mass in GeV,',
     -' second column: the value of F_T=2xF_1, third column: the value', 
     -' of F_2, 4-th column: the value of xF_3)' 

!  neutrino beam  (nb=7 for the anti-neutrino case)
      nb=6
!  proton target  (nt=8 for the neutron target)
      nt=1

      xb=1d-3
      q2=10d0
      bmin=0.8
      bmax=2.2
      nbin=15
      bin=((bmax)-(bmin))/(nbin-1)

      kordhq=1
      msbarm=.false.
      do nn=1,nbin
        rmass(8)=bmin+(bin*(nn-1))
        rm2=rmass(8)**2
        a1=ftnucharm(nb,nt,24,xb,q2,8)
        a3=xb*f3nucharm(nb,nt,24,xb,q2,8)
        a2=f2nucharm(nb,nt,24,xb,q2,8)
        write (*,fmt='(6e13.4)') rmass(8),a1,a2,a3
      end do

      print *,'The same for the MS-bar definition'
      msbarm=.true.
      do nn=1,nbin
        rmass(8)=bmin+(bin*(nn-1))
        rm2=rmass(8)**2
        a1=ftnucharm(nb,nt,24,xb,q2,8)
        a3=xb*f3nucharm(nb,nt,24,xb,q2,8)
        a2=f2nucharm(nb,nt,24,xb,q2,8)
        write (*,fmt='(6e13.4)') rmass(8),a1,a2,a3
      end do

      print *,'The electron-proton DIS c-quark NC semi-inclusive', 
     -' structure functions in', 
     -' the NLO QCD approximation and the pole mass definition at the',
     -' value of Bjorken variable x=0.001 and the transferred momentum', 
     -' squared Q2=10 GeV**2 (first column: the c-quark mass in GeV,',
     -' second column: the value of F_L, third column: the value', 
     -' of F_2)' 

      kordhq=1
      msbarm=.false.
      do nn=1,nbin
        rmass(8)=bmin+(bin*(nn-1))
        rm2=rmass(8)**2
        a1=flcharm_ffn(xb,q2,8)
        a2=f2charm_ffn(xb,q2,8)
        write (*,fmt='(6e13.4)') rmass(8),a1,a2
      end do

      print *,'The same for the NNLO'

      kordhq=2
      do nn=1,nbin
        rmass(8)=bmin+(bin*(nn-1))
        rm2=rmass(8)**2
        a1=flcharm_ffn(xb,q2,8)
        a2=f2charm_ffn(xb,q2,8)
        write (*,fmt='(6e13.4)') rmass(8),a1,a2
      end do

      print *,'The same for the NLO and the MS-bar mass definition'

      kordhq=1
      msbarm=.true.
      do nn=1,nbin
        rmass(8)=bmin+(bin*(nn-1))
        rm2=rmass(8)**2
        a1=flcharm_ffn(xb,q2,8)
        a2=f2charm_ffn(xb,q2,8)
        write (*,fmt='(6e13.4)') rmass(8),a1,a2
      end do

       print *,'The same for the NNLO'

      kordhq=2
      do nn=1,nbin
        rmass(8)=bmin+(bin*(nn-1))
        rm2=rmass(8)**2
        a1=flcharm_ffn(xb,q2,8)
        a2=f2charm_ffn(xb,q2,8)
        write (*,fmt='(6e13.4)') rmass(8),a1,a2
      end do

      stop
      end
